Triangle
      ; Contribution to the #amycoders shortest triangledrawing-compo
      ; by  c960665 <c960665@student.dtu.dk>
      ; and Psycho/Loonies <c960502@student.dtu.dk>

      ; Algorithm: recursive subdivision into 2 new triangles, with
      ;            the recursion substituted by a subdivision-pattern

      ; Speed: about 12 secs/tri on 040-25...

      ; Code size without last rts: 40 bytes

      ; A0: Pointer to chunky buffer (256*256*8)
      ; A1: Pointer to corners
      ; D0: Colour of triangle

      moveq   #0,   d7           ;2 initialize subdivision-pattern

.tri  movem.l (a1),  d1-d3       ;4 get corners
.next btst    d6,    d7          ;2
      beq.s   .sub               ;2    if bit=1     |    if bit=0
      exg     d2,    d3          ;2 (a      , c, b) | (a      , b, c)
.sub  exg     d1,    d3          ;2 (b      , c, a) | (c      , b, a)
      add.l   d2,    d1          ;2 (b+c    , c, a) | (b+c    , b, a)
      lsr.l   #1,    d1          ;2 ((b+c)/2, c, a) | ((b+c)/2, b, a)
      bclr    #15,   d1          ;4

      addq.b  #1,    d6          ;2 256 times (only 16 really needed, but
      bne.s   .next              ;2            this cuts the last 2 bytes)

      swap    d2                 ;2 no problem in trashing d2 now
      lsl.w   #8,    d2          ;2
      lsr.l   #8,    d2          ;2
      move.b  d0,    (a0,d2.l)   ;4 plot

      addq.w   #1,    d7         ;2
      bcc.s    .tri              ;2 next subdivision-pattern

      rts
 
