Send reply to:    tsuikki@lut.fi
Subject:          Triangle compo entry
From:             zuikkis@feandil.lnet.lut.fi (Teemu Suikki)
Date sent:        Fri, 31 Oct 97 14:16:47 +0200
Organization:     Petsoff Limited Partnership
To:               azure@hamburg.roses.de

Hi!

Here's my contribution to the size compo.. 



; 40 bytes filled triangle routine
; by Zuikkis (Teemu Suikki, tsuikki@lut.fi)
;
; This is a variation of the "split in half" recursive 
; algorithm, which many other compo entries probably use.
; This one isn't recursive, instead it scans (nearly) all
; possible left/right halve combinations in a loop.
; This works pretty well, and is two bytes shorter than the
; recursive algorithm I did. :)
;
;a0=chunky
;d0=color
;a1=list of points

	moveq	#0,d7		;d7 = counter
loop1
	movem.l	(a1),d1-d3	;get points
	move.w	d7,d6
loop2
	bpl.s	skip		;which halve to choose?
	exg	d1,d2
skip
	add.l	d2,d1		;calculate midpoint
	lsr.l	#1,d1
	and.w	#$ff,d1
	exg	d1,d3
	
	lsl.w	#1,d6
	bne.s	loop2

	swap	d3		;swap x/y
	lsl.w	#8,d3
	lsr.l	#8,d3
	move.b	d0,(a0,d3.l)	;draw pixel

	addq.w	#1,d7
	bne.s	loop1




-- 
 / Teemu Suikki / email:          /
/  Petsoff LP  /  tsuikki@lut.fi /


