
	fast (atleast i hope so) triangle-filler
	by bolt / logic probe.

	to be honest i'm not sure if it's to be taken as a joke or not :)
	-not tested visually-
	gee, hope it works :)

	; .--------.
	; :                                                         :
	;                    3-point polygon filler                
	; :                                                         :
	; --------
	; d0.l	: color
	; a0	: chunkyptr
	; a1	: wordptr(x1/y1/x2/y2/x3/y3)

tri_dy_o	EQU	0*4
tri_xy_o	EQU	3*4
tri_cr_o	EQU	7*4

	section	trianglefill,code_f

tri_polygon
	move.b	d0,d1
	lsl.w	#8,d0
	move.b	d1,d0
	swap	d0
	move.b	d1,d0
	lsl.w	#8,d0
	move.b	d1,d0			; make longword color
	move.l	d0,a4			; store color
	move.l	#256,a2			; screen width

	moveq.l	#0,d0
	moveq.l	#0,d3
	move.w	(a1)+,d0
	moveq.l	#0,d1
	move.w	(a1)+,d3
	moveq.l	#0,d4
	move.w	(a1)+,d1
	moveq.l	#0,d2
	move.w	(a1)+,d4
	moveq.l	#0,d5
	move.w	(a1)+,d2
	move.w	(a1)+,d5		; put coord-entrys in data-registers

	cmp.l	d3,d4
	bpl.s	tri_nosw1
	exg.l	d0,d1
	exg.l	d3,d4
tri_nosw1
	cmp.l	d4,d5
	bpl.s	tri_nosw3
	exg.l	d1,d2
	exg.l	d4,d5
	cmp.l	d3,d4
	bpl.s	tri_nosw3
	exg.l	d0,d1
	exg.l	d3,d4
tri_nosw3				; sort coord-entrys ascending vertically

	lea.l	tri_variables(pc),a5	; base to variables
	move.l	d5,d6
	sub.l	d3,d6
	beq	tri_nopoly
	move.l	d6,tri_dy_o+1*4(a5)	; insert delta-y 1->3

	move.l	d4,d6
	sub.l	d3,d6
	beq	tri_notop
	move.l	d6,tri_dy_o+0*4(a5)	; insert delta-y 1->2

	move.l	d5,d6
	sub.l	d4,d6
	beq	tri_nobottom
	move.l	d6,tri_dy_o+2*4(a5)	; insert delta-y 2->3

; ---------------------------------------------------------------------------------------

	move.l	d2,d7
	sub.l	d1,d7
	asl.l	#8,d7
	divs.w	d6,d7
	ext.l	d7
	move.l	d7,tri_xy_o+2*4(a5)	; insert xyslope 2->3

	move.l	d1,d6
	sub.l	d0,d6
	asl.l	#8,d6
	move.l	tri_dy+0*4(pc),d7
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+0*4(a5)	; insert xyslope 1->2

	move.l	d2,d6
	sub.l	d0,d6
	asl.l	#8,d6
	move.l	tri_dy+1*4(pc),d7
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+1*4(a5)
	move.l	d6,tri_xy_o+3*4(a5)	; insert xyslope 1->3

	cmp.l	tri_xy+0*4(pc),d6
	smi	tri_cr_o(a5)
	bpl.s	tri_noslopeswap1	; check left/right edge slope

	move.l	tri_xy+0*4(pc),tri_xy_o+1*4(a5)
	move.l	d6,tri_xy_o+0*4(a5)
	move.l	tri_xy+2*4(pc),tri_xy_o+3*4(a5)
	move.l	d6,tri_xy_o+2*4(a5)	; swap slopes if necessary

tri_noslopeswap1

	asl.l	#8,d1
	move.l	d1,a6			; save middle x-coord for correcting slope

	asl.l	#8,d3
	lea.l	(a0,d3.l),a3		; chunkyptr starting on top y-coord

	asl.l	#8,d0
	move.l	d0,d1			; left/right edge

	move.l	a4,d3			; retrieve color

; ---------------------------------------------------------------------------------------

tri_dotop
	move.l	tri_dy+0*4(pc),d7
	subq.w	#1,d7			; length of part/y-counter
tri_yloop1
	add.l	tri_xy+0*4(pc),d0
	add.l	tri_xy+1*4(pc),d1	; add slopes

	move.l	d0,d6
	asr.l	#8,d6
	move.l	d1,d5
	asr.l	#8,d5
	sub.w	d6,d5
	ble.s	tri_norow1		; length of row/x-counter

	lea.l	(a3,d6.l),a1		; chunkyptr starting on left edge

	lsr.w	#1,d5
	bcc.s	tri_nobyte1
	move.b	d3,(a1)+
tri_nobyte1
	lsr.w	#1,d5
	bcc.s	tri_noword1
	move.w	d3,(a1)+
tri_noword1
	subq.w	#1,d5
	bmi.s	tri_norow1
tri_xloop1
	move.l	d3,(a1)+
	dbra	d5,tri_xloop1		; count xloop
tri_norow1
	add.l	a2,a3
	dbra	d7,tri_yloop1		; count yloop

; ---------------------------------------------------------------------------------------

	tst.l	tri_cr_o(a5)		; check which side to correct
	beq.s	tri_correctleft
	move.l	a6,d1
	bra.s	tri_skipcorrectleft
tri_correctleft
	move.l	a6,d0
tri_skipcorrectleft			; correct slope error

; ---------------------------------------------------------------------------------------

tri_dobottom
	move.l	tri_dy+2*4(pc),d7
	subq.w	#1,d7			; length of part/y-counter
	bmi.s	tri_nopoly
tri_yloop2
	add.l	tri_xy+2*4(pc),d0
	add.l	tri_xy+3*4(pc),d1

	move.l	d0,d6
	asr.l	#8,d6
	move.l	d1,d5
	asr.l	#8,d5
	sub.w	d6,d5
	ble.s	tri_norow2		; length of row/x-counter

	lea.l	(a3,d6.l),a1		; chunkyptr starting on left edge

	lsr.w	#1,d5
	bcc.s	tri_nobyte2
	move.b	d3,(a1)+
tri_nobyte2
	lsr.w	#1,d5
	bcc.s	tri_noword2
	move.w	d3,(a1)+
tri_noword2
	subq.w	#1,d5
	bmi.s	tri_norow2
tri_xloop2
	move.l	d3,(a1)+
	dbra	d5,tri_xloop2		; count xloop
tri_norow2
	add.l	a2,a3
	dbra	d7,tri_yloop2		; count yloop
tri_nopoly
	rts

; --------------------------------------------- compensate for delta-y 2->3 = 0 ------

tri_nobottom
	move.l	#0,tri_dy_o+2*4(a5)	; correct deltas

	move.l	d2,d6
	sub.l	d1,d6
	bpl.s	tri_noedgeswap1
	exg.l	d1,d2
tri_noedgeswap1				; sort left/right

	move.l	d1,d6
	sub.l	d0,d6
	asl.l	#8,d6
	move.l	tri_dy+0*4(pc),d7
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+0*4(a5)	; insert xyslope 1->2

	move.l	d2,d6
	sub.l	d0,d6
	asl.l	#8,d6
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+1*4(a5)	; insert xyslope 1->3

	asl.l	#8,d3
	lea.l	(a0,d3.l),a3		; chunkyptr starting on top y-coord

	asl.l	#8,d0
	move.l	d0,d1			; left/right edge

	move.l	a4,d3			; retrieve color
	bra	tri_dotop

; --------------------------------------------- compensate for delta-y 1->2 = 0 ------

tri_notop
	move.l	tri_dy+1*4(pc),tri_dy_o+2*4(a5)
	move.l	#0,tri_dy_o+0*4(a5)	; correct deltas

	move.l	d1,d6
	sub.l	d0,d6
	bpl.s	tri_noedgeswap2
	neg.l	d6
	exg.l	d0,d1
tri_noedgeswap2				; sort left/right

	move.l	d2,d6
	sub.l	d0,d6
	asl.l	#8,d6
	move.l	tri_dy+1*4(pc),d7
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+2*4(a5)	; insert xyslope 1->3

	move.l	d2,d6
	sub.l	d1,d6
	asl.l	#8,d6
	divs.w	d7,d6
	ext.l	d6
	move.l	d6,tri_xy_o+3*4(a5)	; insert xyslope 2->3

	asl.l	#8,d3
	lea.l	(a0,d3.l),a3		; chunkyptr starting on top y-coord

	asl.l	#8,d0
	asl.l	#8,d1			; left/right edge

	move.l	a4,d3			; retrieve color
	bra	tri_dobottom

; ---------------------------------------------------------------------- arrays ------

	cnop	0,4

tri_variables
tri_dy		dc.l	0,0,0
tri_xy		dc.l	0,0,0,0
tri_cr		dc.l	0
